$Barber::Prefix = "Barber_Hair";
$Barber::Font = "Impact";


function Barber_importDatablocks() //Run this after Datablocks have loaded on server start
{
	if(isObject(Barber_Haircuts))
		Barber_Haircuts.delete();
	%prefix = $Pref::Barber::Prefix;
	%group = new ScriptGroup(Barber_Haircuts);
	%count = DataBlockGroup.getCount();
	for(%i=0; %i<%count; %i++)
		if(getSubStr(DataBlockGroup.getObject(%i).getName(),0,(strlen(%prefix)))$=%prefix)
		{
			%hairtype = getWord(strReplace(DataBlockGroup.getObject(%i).getName(),"_"," "),2);
			//Does a SimSet for the hairtype already exist?
			for(%j=0; %j<Barber_Haircuts.getCount(); %j++)
				if(Barber_Haircuts.getObject(%j).getName()$=%hairtype)
				{
					//We found it! Let's add the datablock to the Set.
					%hairSetFound = 1;
					Barber_Haircuts.getObject(%j).add(DataBlockGroup.getObject(%i));
				}
			//Bummer, it doesn't exist. Let's make a SimSet then.
			if(%hairSetFound != 1)
			{
				%group.add(%hairSet = new SimSet(%hairtype));
				%hairSet.add(DataBlockGroup.getObject(%i));
			}
			%hairSetFound = 0;
		}
}

function getHairIndex(%hair)
{
	if(!isObject(%hair))
		return;
	%style = getWord(strReplace(%hair.getName(),"_"," "),2);
	%color = getWord(strReplace(%hair.getName(),"_"," "),3);
	%count = Barber_Haircuts.getCount();
	for(%i=0; %i<%count; %i++)
		if(Barber_Haircuts.getObject(%i).getName() $= %style)
		{
			%set = Barber_Haircuts.getObject(%i);
			break;
		}
	if(%set $= "")
		return;
	%count = %set.getCount();
	for(%j=0; %j<%count; %j++)
		if(%set.getObject(%j).getName() $= %hair.getName())
			return %i SPC %j;
}

function GameConnection::openBarberMenu(%client,%useRaycastCamera)
{
	if(%client.currMenu $= "Barber") return false;
	%player = %client.player;
	if(!%useRaycastCamera)
	{
		%raycast = containerRaycast(%player.getEyePoint(), VectorAdd(%player.getEyePoint(),VectorScale(%player.getEyeVector(),$Pref::Barber::CameraLength)),$Typemasks::All,%client.player);
		if(%raycast !$= "")
			%pos = getWords(%raycast,1,3);
		else
			%pos = VectorAdd(%player.getEyePoint(),VectorScale(%player.getEyeVector(),5));
		%delta = vectorSub(%player.getEyePoint(), %pos);
		%deltaX = getWord(%delta, 0);
		%deltaY = getWord(%delta, 1);
		%deltaZ = getWord(%delta, 2);
		%deltaXYHyp = vectorLen(%deltaX SPC %deltaY SPC 0);

		%rotZ = mAtan(%deltaX, %deltaY) * -1; 
		%rotX = mAtan(%deltaZ, %deltaXYHyp);

   		%aa = eulerRadToMatrix(%rotX SPC 0 SPC %rotZ);
		%cam=%client.camera;
		%cam.setTransform(%pos SPC %aa);
		%cam.setFlyMode();
		%cam.mode = "Observer";
		%client.setControlObject(%cam);
		%cam.setControlObject(%player);
	}
	if(%client.hair !$= "")
	{
		%client.hairIndex = getHairIndex(%client.hair);
		%client.changeHairType(%client.hair);
	}
	else
	{
		%client.hairIndex = "0 0";
		%client.changeHairType(Barber_Haircuts.getObject(getWord(%client.hairIndex,0)).getObject(getWord(%client.hairIndex,1)));
	}
	//Stop player from moving
	$Barber::Speed[%client] = new SimObject();
	$Barber::Speed[%client].BackwardSpeed = %player.getMaxBackwardSpeed();
	$Barber::Speed[%client].CrouchBackwardSpeed = %player.getMaxCrouchBackwardSpeed();
	$Barber::Speed[%client].CrouchForwardSpeed = %player.getMaxCrouchForwardSpeed();
	$Barber::Speed[%client].CrouchSideSpeed = %player.getMaxCrouchSideSpeed();
	$Barber::Speed[%client].ForwardSpeed = %player.getMaxForwardSpeed();
	$Barber::Speed[%client].SideSpeed = %player.getMaxSideSpeed();
	%player.setMaxBackwardSpeed(0);
	%player.setMaxCrouchBackwardSpeed(0);
	%player.setMaxCrouchForwardSpeed(0);
	%player.setMaxCrouchSideSpeed(0);
	%player.setMaxForwardSpeed(0);
	%player.setMaxSideSpeed(0);

	Barber_IdleActivity(%client);
	%client.currMenu = "Barber";
}
registerOutputEvent("GameConnection","openBarberMenu", "bool",1);

function GameConnection::closeBarberMenu(%client,%clearPrint)
{
	%player = %client.player;
	if(%clearPrint)
		commandToClient(%client,'CenterPrint',"",0);
	%cam=%client.camera;
	%client.setControlObject(%client.player);
	%cam.setControlObject(0);
	%cam.setFlyMode();
	%client.hairIndex = "";
	%client.currMenu = "";
	%player.mountImage(%client.hair,2);
	//Give player back movement Speed
	%player.setMaxBackwardSpeed($Barber::Speed[%client].BackwardSpeed);
	%player.setMaxCrouchBackwardSpeed($Barber::Speed[%client].CrouchBackwardSpeed);
	%player.setMaxCrouchForwardSpeed($Barber::Speed[%client].CrouchForwardSpeed);
	%player.setMaxCrouchSideSpeed($Barber::Speed[%client].CrouchSideSpeed);
	%player.setMaxForwardSpeed($Barber::Speed[%client].ForwardSpeed);
	%player.setMaxSideSpeed($Barber::Speed[%client].SideSpeed);
	deleteVariables("$Barber::Speed["@%client@"]");

	cancel(Barber_Haircuts.idle[%client]);
}

function GameConnection::changeHairType(%client,%hair,%silent)
{
	%player=%client.player;
	%player.mountImage(%hair,2);
	if(%silent != 1)
	{
		%player.playThread(0,plant);
		%client.play2D(Barber_Audio_HaircutSwitch);
		%client.hairType = %hair;
		commandToClient(%client,'CenterPrint',"<font:"@$Pref::Barber::Font@":64><color:FFFF11>" @ %hair.uiName @ "\n<font:"@$Pref::Barber::Font@":32><spush><color:FFFF11><<spop> \c6 Left click        E = Dye        Right click  <color:FFFF11>><spop>\n\c6Press spacebar to choose this haircut. Press Q for Quit.", -1);
		Barber_IdleActivity(%client);
	}
}

function GameConnection::buyHairType(%client)
{
	if(%client.hairIndex $= "")
		return;
	%datablock = Barber_Haircuts.getObject(getWord(%client.hairIndex,0)).getObject(getWord(%client.hairIndex,1));
	%client.hair = %datablock;
	commandToClient(%client,'CenterPrint',"<font:impact:32>\c6Enjoy your new" SPC %datablock.uiName SPC "hair.", 3);
	%client.hairIndex = "";
	$Barber::Save::BL_ID[%client.bl_id] = %client.hair;
	%client.closeBarberMenu(0);
}

function GameConnection::changeHairColor(%client)
{
	%player = %client.player;
	%client.hairIndex = getWord(%client.hairIndex,0) SPC ((getWord(%client.hairIndex,1)+1) % Barber_Haircuts.getObject(getWord(%client.hairIndex,0)).getCount());
	%hair = Barber_Haircuts.getObject(getWord(%client.hairIndex,0)).getObject(getWord(%client.hairIndex,1));
	%player.mountImage(%hair,2);
	%player.playThread(0,plant);
	%client.play2D(Barber_Audio_HaircutDye);
	commandToClient(%client,'CenterPrint',"<font:"@$Pref::Barber::Font@":64><color:FFFF11>" @ %hair.uiName @ "\n<font:"@$Pref::Barber::Font@":32><spush><color:FFFF11><<spop> \c6 Left click        E = Dye        Right click  <color:FFFF11>><spop>\n\c6Press spacebar to choose this haircut. Press Q for Quit.", -1);
	Barber_IdleActivity(%client);
}

function Barber_IdleActivity(%client)
{
	cancel(Barber_Haircuts.idle[%client]);
	Barber_Haircuts.idle[%client] = %client.schedule($Pref::Barber::BarberMaxIdleDuration * 1000,0,closeBarberMenu,1);
}

function Barber_saveTick()
{
	if(isEventPending($Barber::SaveSchedule)) cancel($Barber::SaveSchedule);
	export("$Barber::Save::*",$Pref::Barber::SavePath@$Pref::Barber::SaveFile);
	schedule($Barber::SaveFrequency * 1000, $Barber::SaveSchedule, "Barber_saveTick");
}

function Binds_Barber_Menu(%client,%bind)
{
	switch$(%bind)
	{
		case "leftClickDown":
			if(getWord(%client.hairIndex,0)-1<0)
				%client.hairIndex = Barber_Haircuts.getCount()-1 SPC getWord(%client.hairIndex,1);
			else
				%client.hairIndex = getWord(%client.hairIndex,0)-1 SPC getWord(%client.hairIndex,1);
			%client.changeHairType(Barber_Haircuts.getObject(getWord(%client.hairIndex,0)).getObject(getWord(%client.hairIndex,1)));
		case "rightClickDown":
			%client.hairIndex = ((getWord(%client.hairIndex,0)+1) % Barber_Haircuts.getCount()) SPC getWord(%client.hairIndex,1);
			%client.changeHairType(Barber_Haircuts.getObject(getWord(%client.hairIndex,0)).getObject(getWord(%client.hairIndex,1)));
		case "useSprayCan":
			%client.changeHairColor();
			return 1;
		case "useTool":
			%client.closeBarberMenu(1);
			return 1;
		case "jumpDown":
			%client.buyHairType();
	}
}

package BarberPack
{
	function GameConnection::spawnPlayer(%client) {
		Parent::spawnplayer(%client);
		if(!%client.hairSaveLoaded) { %client.hair = $Barber::Save::BL_ID[%client.bl_id]; %client.hairSaveLoaded = true; }
		if(isObject(%client.hair)) {
			%client.player.mountImage(%client.hair,2);
		}
	}
};
deactivatePackage(BarberPack); activatePackage(BarberPack);